UNIT mTWaggon;

interface

uses  mSum,mTEreignisBearbeiter;
// Uses-Klausel ggf. anpassen

type
   TWaggon = CLASS(TEreignisbearbeiter)

     // Attribute
     private
        naechsterWaggon : TWaggon;
     protected
         zHPosition : Zahl;
         zLaenge : Zahl;
         zVPosition : Zahl;
     public
        hatStift : BuntStift;

     //Objektbeziehungen:
        // kenntTWaggon () of TWaggon;
        // kenntTWaggon (0..1) of TWaggon;

     // Methoden
     public
        constructor init(pHPosition,pVPosition,pLaenge:Zahl;pMaus:Maus);
        procedure bearbeiteMeinenMausClick(sender:TObject); override;
        procedure bearbeiteMeinenMausDoppelKlick(sender:TObject); override;
        procedure bewegeUm(pDistanz:Zahl);
        procedure koppleAn(pWaggon:TWaggon);
        procedure zeichne; virtual; abstract;
        function hPosition : Zahl;
        function innerhalb : Wahrheitswert;
        function vPosition : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TWaggon: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TWaggon.init(pHPosition,pVPosition,pLaenge:Zahl;pMaus:Maus);
begin
  inherited init(pMaus);
  zHPosition:=pHPosition;
  zVPosition:=pVPosition;
  zLaenge   :=pLaenge;  
  hatStift  :=BuntStift.init;
  hatStift.wechsle;
  naechsterWaggon := nil;
  self.zeichne;
end;

//-------- bearbeiteMeinenMausClick (public) ---------------------------
procedure TWaggon.bearbeiteMeinenMausClick(sender:TObject);
begin
   if self.innerhalb
      then meineClickAktion(self) ;
   if naechsterEreignisBearbeiter <> nil
      then naechsterEreignisbearbeiter.bearbeiteMeinenMausClick(sender)
end;

//-------- bearbeiteMeinenMausDoppelKlick (public) ---------------------
procedure TWaggon.bearbeiteMeinenMausDoppelKlick(sender:TObject);
begin
   if self.innerhalb
      then meineDoppelKlickAktion(self) ;
   if naechsterEreignisBearbeiter <> nil
      then naechsterEreignisbearbeiter.bearbeiteMeinenMausDoppelKlick(sender)
end;

//-------- bewegeUm (public) -------------------------------------------
procedure TWaggon.bewegeUm(pDistanz:Zahl);
begin
  self.zeichne;
  zHPosition := zHPosition - pDistanz;
  self.zeichne;
  if naechsterWaggon <> nil then 
     naechsterWaggon.bewegeUm(pDistanz); 
end;

//-------- koppleAn (public) -------------------------------------------
procedure TWaggon.koppleAn(pWaggon:TWaggon);
begin
  if naechsterWaggon = nil then begin
     naechsterWaggon := pWaggon;
     naechsterWaggon.zeichne; //Lschen an der alten Position
     naechsterWaggon.zHPosition := self.zHPosition+self.zLaenge;
     naechsterWaggon.zVPosition := self.zVPosition;
     naechsterWaggon.zeichne;
  end
  else begin
     naechsterWaggon.koppleAn(pWaggon);
  end
end;

//-------- hPosition (public) ------------------------------------------
function TWaggon.hPosition : Zahl;
begin
  result := zHPosition
end;

//-------- innerhalb (public) ------------------------------------------
function TWaggon.innerhalb : Wahrheitswert;
begin
  result :=
       (kenntMaus.hPosition > zhPosition ) and
       (kenntMaus.hPosition < zhPosition + zLaenge) and
       (kenntMaus.vPosition > zvPosition-50) and
       (kenntMaus.vPosition < zvPosition+10)
end;

//-------- vPosition (public) ------------------------------------------
function TWaggon.vPosition : Zahl;
begin
  result := zVPosition
end;

//-------- gibFrei (public) --------------------------------------------
destructor TWaggon.gibFrei;
begin
  self.zeichne;
  hatStift.gibFrei;
  if naechsterWaggon <> nil then
     naechsterWaggon.gibFrei 
end;

end.
