UNIT mTWaggon;

interface

uses    mSum;
// Uses-Klausel ggf. anpassen

type
   TWaggon = CLASS

     // Attribute
     private
        naechsterWaggon : TWaggon;
     protected
         hatStift : Stift;
         zHPosition : Zahl;
         zLaenge : Zahl;
         zVPosition : Zahl;

     //Objektbeziehungen:
        // kenntTWaggon () of TWaggon;
        // kenntTWaggon (0..1) of TWaggon;

     // Methoden
     public
        constructor init(pHPosition,pVPosition,pLaenge:Zahl);
        procedure bewegeUm(pDistanz:Zahl);
        procedure koppleAn(pWaggon:TWaggon);
        procedure zeichne; virtual; abstract;
        function hPosition : Zahl;
        function vPosition : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TWaggon: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TWaggon.init(pHPosition,pVPosition,pLaenge:Zahl);
begin
  zHPosition:=pHPosition;
  zVPosition:=pVPosition;
  zLaenge   :=pLaenge;  
  hatStift  :=Stift.init;
  hatStift.wechsle;
  naechsterWaggon := nil;
  self.zeichne;
end;

//-------- bewegeUm (public) -------------------------------------------
procedure TWaggon.bewegeUm(pDistanz:Zahl);
begin
  self.zeichne;
  zHPosition := zHPosition - pDistanz;
  self.zeichne;
  if naechsterWaggon <> nil then 
     naechsterWaggon.bewegeUm(pDistanz); 
end;

//-------- koppleAn (public) -------------------------------------------
procedure TWaggon.koppleAn(pWaggon:TWaggon);
begin
  if naechsterWaggon = nil then begin
     naechsterWaggon := pWaggon;
     naechsterWaggon.zeichne; //Lschen an der alten Position
     naechsterWaggon.zHPosition := self.zHPosition+self.zLaenge;
     naechsterWaggon.zVPosition := self.zVPosition;
     naechsterWaggon.zeichne;
  end
  else begin
     naechsterWaggon.koppleAn(pWaggon);
  end
end;

//-------- hPosition (public) ------------------------------------------
function TWaggon.hPosition : Zahl;
begin
  result := zHPosition
end;

//-------- vPosition (public) ------------------------------------------
function TWaggon.vPosition : Zahl;
begin
  result := zVPosition
end;

//-------- gibFrei (public) --------------------------------------------
destructor TWaggon.gibFrei;
begin
  self.zeichne;
  hatStift.gibFrei;
  if naechsterWaggon <> nil then
     naechsterWaggon.gibFrei 
end;

end.
