UNIT mTEreignisVerteilerAnwendung;

interface

uses         mSum,mTAnwendung, mTWaggon, mTGueterwagen, mTPersonenwagen, mTLokomotive,
         mTKnopf, mTRechteckKnopf;
// Uses-Klausel ggf. anpassen

type
   TEreignisVerteilerAnwendung = CLASS(TAnwendung)

     // Attribute
     protected
         ErsterKnopf : TKnopf;
         zBeenden : Wahrheitswert;
         zMausunten : Wahrheitswert;

     //Objektbeziehungen:
        // hatTKnopf : TKnopf;

     // Methoden
     public
        constructor init; override;
        procedure bearbeiteLeerlauf; virtual;
        procedure bearbeiteMausClick; virtual;
        procedure bearbeiteMausDoppelklick; virtual;
        procedure bearbeiteTastaturDruck(pZeichen:Zeichen); virtual;
        procedure beenden;
        procedure run; override;
        destructor gibfrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TEreignisVerteilerAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TEreignisVerteilerAnwendung.init;
begin
  inherited init;
  zBeenden           := falsch;
  zMausunten         := falsch;
end;

  // Aktionsteil

//-------- bearbeiteLeerlauf (public) ----------------------------------
procedure TEreignisVerteilerAnwendung.bearbeiteLeerlauf;
begin
   ersterKnopf.bearbeiteMeinenLeerlauf 
end;

//-------- bearbeiteMausClick (public) ---------------------------------
procedure TEreignisVerteilerAnwendung.bearbeiteMausClick;
begin
    ersterKnopf.bearbeiteMeinenMausClick;
end;

//-------- bearbeiteMausDoppelklick (public) ---------------------------
procedure TEreignisVerteilerAnwendung.bearbeiteMausDoppelklick;
begin
    ersterKnopf.bearbeiteMeinenMausDoppelklick;
end;

//-------- bearbeiteTastaturDruck (public) -----------------------------
procedure TEreignisVerteilerAnwendung.bearbeiteTastaturDruck(pZeichen:Zeichen);
begin
    ersterKnopf.bearbeiteMeinenTastaturdruck(pZeichen)
end;

//-------- beenden (public) --------------------------------------------
procedure TEreignisVerteilerAnwendung.beenden;
begin
   zBeenden := True
end;

//-------- run (public) ------------------------------------------------
procedure TEreignisVerteilerAnwendung.run;
begin
  repeat
     if dieMaus.istGedrueckt
       then begin
              if not zMausUnten
                then begin
                       zMausUnten := True;
                       bearbeiteMausClick
                     end
                else begin
                        bearbeiteLeerlauf
                       //eigentlich : bearbeiteMausUnten
                     end
            end
       else begin //Maus ist nicht gedrckt
              zMausUnten := False;
              if dieMaus.doppelklick
                then begin
                       bearbeiteMausDoppelklick
                     end
                else begin
                       if dieTastatur.wurdeGedrueckt
                         then begin
                                bearbeiteTastaturDruck(dieTastatur.zeichen)
                              end
                         else begin
                                bearbeiteLeerlauf
                              end
                     end
            end
  until zBeenden
end;

//-------- gibfrei (public) --------------------------------------------
destructor TEreignisVerteilerAnwendung.gibfrei;
begin
   ersterKnopf.gibFrei;
   inherited gibFrei
end;  

end.
