UNIT mTEreignisKnopf;

interface

uses        dialogs, mSuM, mTEreignisanwendung;
// Uses-Klausel ggf. anpassen

type
   TEreignisKnopf = CLASS

     // Attribute
     private
        naechsterKnopf : TEreignisKnopf;
     protected
         hatStift : BuntStift;
         kenntMaus : Maus;
         kenntAnwendung : TEreignisanwendung;
         kannGedruecktWerden : Wahrheitswert;
         zGroesse : Zahl;
         zXPos : Zahl;
         zYPos : Zahl;
         zAufschrift : Zeichenkette;

     //Objektbeziehungen:
        // kenntTEreignisKnopf () of TEreignisKnopf;
        // kenntTEreignisKnopf (0..1) of TEreignisKnopf;

     // Methoden
     protected
        procedure zeichne; virtual; abstract;
     public
        constructor init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus;pAnwendung:TEreignisanwendung);
        procedure bearbeiteLeerlauf; virtual; abstract;
        procedure bearbeiteMausClick; virtual;
        procedure bearbeiteMausDoppelklick; virtual; abstract;
        procedure bearbeiteTastaturdruck; virtual; abstract;
        procedure haengeKnopfAn(pKnopf:TEreignisKnopf);
        function angeklickt : Wahrheitswert; virtual; abstract;
        function innerhalb : Wahrheitswert; virtual; abstract;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TEreignisKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TEreignisKnopf.init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus;pAnwendung:TEreignisanwendung);
begin
  kannGedruecktWerden := True;
  zXpos := pX;
  zYPos := py;
  zGroesse := pGroesse;
  zAufschrift := pAufschrift;
  kenntMaus := pMaus;
  kenntAnwendung := pAnwendung;
  naechsterKnopf := nil;
  hatStift := BuntStift.init;
  hatStift.wechsle;
  zeichne
end;

//-------- bearbeiteMausClick (public) ---------------------------------
procedure TEreignisKnopf.bearbeiteMausClick;
begin
  //showmessage('Knopf '+zAufschrift+ ' bearbeitet Mausclick.');
  if naechsterKnopf = nil then
     //showmessage('Knopf '+zAufschrift+ ' ist letzter Knopf.')
  else
  begin
     //showmessage ('Knopf '+zAufschrift+ ' gibt Klick weiter.');
     naechsterKnopf.bearbeiteMausClick;
     //showmessage('Folgeknpfe von ' + zAufschrift +' sind fertig');
  end   
end;

//-------- haengeKnopfAn (public) --------------------------------------
procedure TEreignisKnopf.haengeKnopfAn(pKnopf:TEreignisKnopf);
begin
  if naechsterKnopf = nil
     then naechsterKnopf := pKnopf
     else naechsterKnopf.haengeKnopfAn(pKnopf);
end;

//-------- gibFrei (public) --------------------------------------------
destructor TEreignisKnopf.gibFrei;
begin
  zeichne
end;

end.
