UNIT mTEreignisAnwendung;

interface

uses      dialogs,mSum,mUhr,mTAnwendung,mTEndeKnopf;
// Uses-Klausel ggf. anpassen

type
   TEreignisAnwendung = CLASS(TAnwendung)

     // Attribute
     protected

         zBeenden : Wahrheitswert;
         zMausUnten : Wahrheitswert;
     public
        dieUhr : Uhr;
        ErsterKnopf : TEndeKnopf;
     //Objektbeziehungen:
        // hatTEndeKnopf : TEndeKnopf;

     // Methoden
     public
        constructor init; override;
        procedure bearbeiteLeerlauf; virtual;
        procedure bearbeiteMausClick; virtual;
        procedure bearbeiteMausDoppelklick; virtual;
        procedure bearbeiteTastaturDruck; virtual;
        procedure beenden;
        procedure run; override;
        function vergangeneZeit : Zahl;
        destructor gibfrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TEreignisAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TEreignisAnwendung.init;
begin
  inherited init;
  ErsterKnopf       := TEndeKnopf.init(derBildschirm.breite-101,1,100,'Ende',dieMaus,self);
  dieUhr             := Uhr.init;
  zBeenden           := falsch;
  zMausunten         := falsch;
end;

  // Aktionsteil

//-------- bearbeiteLeerlauf (public) ----------------------------------
procedure TEreignisAnwendung.bearbeiteLeerlauf;
begin
  ErsterKnopf.bearbeiteLeerlauf
end;

//-------- bearbeiteMausClick (public) ---------------------------------
procedure TEreignisAnwendung.bearbeiteMausClick;
begin
  ErsterKnopf.bearbeiteMausClick
end;

//-------- bearbeiteMausDoppelklick (public) ---------------------------
procedure TEreignisAnwendung.bearbeiteMausDoppelklick;
begin
  ErsterKnopf.bearbeiteMausDoppelklick
end;

//-------- bearbeiteTastaturDruck (public) -----------------------------
procedure TEreignisAnwendung.bearbeiteTastaturDruck;
begin
  ErsterKnopf.bearbeiteTastaturdruck
end;

//-------- beenden (public) --------------------------------------------
procedure TEreignisAnwendung.beenden;
begin
   zBeenden := True
end;

//-------- run (public) ------------------------------------------------
procedure TEreignisAnwendung.run;
begin
  repeat
     if dieMaus.istGedrueckt then begin
        if not zMausUnten then begin
           zMausUnten := True;
           bearbeiteMausClick
        end
        else begin
           bearbeiteLeerlauf
           //normaler Weise : bearbeiteMausUnten
        end
     end
     else begin //Maus ist nicht gedrckt
        zMausUnten := False;
        if dieMaus.doppelklick then begin
           bearbeiteMausDoppelklick
        end
        else begin
           if dieTastatur.wurdeGedrueckt then begin
              bearbeiteTastaturDruck
           end
           else begin
              bearbeiteLeerlauf
           end
        end
     end
  until zBeenden

end;

  // Aufrumen

//-------- vergangeneZeit (public) -------------------------------------
function TEreignisAnwendung.vergangeneZeit : Zahl;
begin
  result := (((dieUhr.stunde * 60 + dieUhr.minute)*60 + dieUhr.sekunde)*1000)+
             dieUhr.millisekunde
//  result := ((dieUhr.minute)*60 + dieUhr.sekunde)*1000+
//             dieUhr.millisekunde
end;

//-------- gibfrei (public) --------------------------------------------
destructor TEreignisAnwendung.gibfrei;
begin
end;  

end.
