UNIT mTRechteckKnopf;

interface

uses        dialogs, mSuM, mTAnwendung,mTEreignisBearbeiter;
// Uses-Klausel ggf. anpassen

type
   TRechteckKnopf = CLASS(TEreignisbearbeiter)

     // Attribute
     protected
         hatStift : BuntStift;
         istUnten : Wahrheitswert;
         zGroesse : Zahl;
         zXPos : Zahl;
         zYPos : Zahl;
         zAufschrift : Zeichenkette;

     // Methoden
     protected
        procedure zeichne;
     public
        constructor init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus;pAnwendung:TAnwendung);
        function innerhalb : Wahrheitswert;
        destructor gibFrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TRechteckKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (protected) -----------------------------------------
procedure TRechteckKnopf.zeichne;
begin
  hatStift.bewegeBis(zXPos,zYPos);
  hatStift.zeichneRechteck(zGroesse,15);
  hatStift.bewegeBis(zXPos+(zGroesse-hatStift.Textbreite(zAufschrift))/2,zYPos+1);
  hatStift.schreibeText(zAufschrift);
end;

//-------- init (public) -----------------------------------------------
constructor TRechteckKnopf.init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus;pAnwendung:TAnwendung);
begin
  inherited init(pAnwendung);
  istUnten := True;
  zXpos := pX;
  zYPos := py;
  zGroesse := pGroesse;
  zAufschrift := pAufschrift;
  naechsterBearbeiter := nil;
  hatStift := BuntStift.init;
  hatStift.wechsle;
  zeichne
end;

//-------- innerhalb (public) ------------------------------------------
function TRechteckKnopf.innerhalb : Wahrheitswert;
begin
  result :=
       (kenntMaus.hPosition > zXpos ) and
       (kenntMaus.hPosition < zXPos + zGroesse) and
       (kenntMaus.vPosition > zYPos) and
       (kenntMaus.vPosition < zYPos+12)
end;

//-------- gibFrei (public) --------------------------------------------
destructor TRechteckKnopf.gibFrei;
begin
  hatStift.radiere;
  hatStift.setzeFarbe(weiss);
  hatStift.setzeFuellMuster(gefuellt);
  hatStift.bewegeBis(zXPos,zYPos);
  hatStift.zeichneRechteck(zGroesse,15);
  hatStift.wechsle;
  hatStift.setzeFarbe(schwarz);
  inherited gibFrei
end;

end.
