UNIT mTZeitgeber;

interface

uses     mSuM,mTEreignisanwendung,mTEreignisbearbeiter;
// Uses-Klausel ggf. anpassen

type
   TZeitgeber = CLASS(TEreignisbearbeiter)

     // Attribute
     private
        zAktiv : Wahrheitswert;
        letzterZeitpunkt : Zahl;
        zZeittakt : Zahl;

     // Methoden
     public
        constructor init(pZeittakt:GanzeZahl;pAnwendung:TEreignisanwendung);
        procedure aktion;
        procedure bearbeiteLeerlauf; override;
        procedure setzeZeittakt(pDauer:GanzeZahl);
        procedure start;
        procedure stopp;

   end;

implementation

uses     mTWaggonEreignisAnwendung;

//+---------------------------------------------------------------------
//|         TZeitgeber: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TZeitgeber.init(pZeittakt:GanzeZahl;pAnwendung:TEreignisanwendung);
begin
   inherited init(pAnwendung);
   zZeittakt := pZeittakt;
   zAktiv := False;
   letzterZeitpunkt := tEReignisanwendung(kenntAnwendung).vergangeneZeit;
  //Hier Code einfgen.
end;

//-------- aktion (public) ---------------------------------------------
procedure TZeitgeber.aktion;
begin
  tWaggonereignisAnwendung(kenntAnwendung).meineLokomotive.bewegeUm(2)
end;

//-------- bearbeiteLeerlauf (public) ----------------------------------
procedure TZeitgeber.bearbeiteLeerlauf;
begin
   if zAktiv then begin
      if TEreignisanwendung(kenntAnwendung).vergangeneZeit > letzterZeitpunkt + zZeittakt then
      begin
        letzterZeitpunkt := TEreignisanwendung(kenntAnwendung).vergangeneZeit;
        aktion;
      end;
   end;
   inherited bearbeiteLeerlauf
end;

//-------- setzeZeittakt (public) --------------------------------------
procedure TZeitgeber.setzeZeittakt(pDauer:GanzeZahl);
begin
  zZeittakt := pDauer;
  letzterZeitpunkt := Tereignisanwendung(kenntAnwendung).vergangeneZeit;
end;

//-------- start (public) ----------------------------------------------
procedure TZeitgeber.start;
begin
  zAktiv := Wahr;
  letzterZeitpunkt := TEreignisanwendung(kenntAnwendung).vergangeneZeit;
end;

//-------- stopp (public) ----------------------------------------------
procedure TZeitgeber.stopp;
begin
  zAktiv := Falsch
end;

end.
